# -*- coding:Utf-8 -*-
import es, re, psyco
psyco.full()


admin = set()
command = set()
regex = re.compile('//.*|(\r)+|(\n)+|(")+|')

class DmConfig(object):
    """ Config Management """
    def __init__(self):
        self.cfgpath = es.getString("eventscripts_gamedir") + "/cfg/dm_python/"
        self.steamid = es.ServerVar("dp_admin_steamid", "", "[dm_python] Administration steamid")
        self.admin = es.ServerVar("dp_admin_command", "", "[dm_python] Administration menu command")
        self.command = es.ServerVar("dp_menu_command", "", "[dm_python] deathmatch menu command")
        self.timeout = es.ServerVar("dp_menu_timeout", "", "[dm_python] menu time out")
        self.method = es.ServerVar("dp_respawn_method", "", "[dm_python] plugin used for respawn players")
        self.random = es.ServerVar("dp_respawn_random", "", "[dm_python] respawn player at his team spawn")
        self.respawn = es.ServerVar("dp_respawn_time", "", "[dm_python] time for respawn players")
        self.dissolver = es.ServerVar("dp_ragdoll_dissolver", "", "[dm_python] dissolve ragdoll")

        self.assaultsuit = es.ServerVar("dp_give_assaultsuit", "", "[dm_python] give assaultsuit")
        self.nightvision = es.ServerVar("dp_give_nightvision", "", "[dm_python] give nightvision")
        self.hegrenade = es.ServerVar("dp_hegrenade_max", "", "[dm_python] hegrenade max")
        self.flashbang = es.ServerVar("dp_flashbang_max", "", "[dm_python] flashbang max")
        self.smokegrenade = es.ServerVar("dp_smokegrenade_max", "", "[dm_python] smokegrenade max")
        self.botPrimary = es.ServerVar("dp_bot_primary", "", "[dm_python] primary weapon allowed for bot")
        self.botSecondary = es.ServerVar("dp_bot_secondary", "", "[dm_python] secondary weapon allowed for bot")

        self.kills = es.ServerVar("dp_vote_kills", "", "[dm_python] activate votemap")
        self.time = es.ServerVar("dp_vote_time", "", "[dm_python] time for vote")
        self.maxmap = es.ServerVar("dp_vote_maxmap", "", "[dm_python] number of map added in vote")
        self.lastmaps = es.ServerVar("dp_vote_lastmaps", "", "[dm_python] don't add last maps played in vote")

        es.regclientcmd("_dp_cvar_admin", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_command", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_timeout", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_method", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_random", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_respawn", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_dissolver", "dm_python/cvarValue", "[dm_python] internal command for in-game config")

        es.regclientcmd("_dp_cvar_assaultsuit", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_nightvision", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_hegrenade", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_flashbang", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_smokegrenade", "dm_python/cvarValue", "[dm_python] internal command for in-game config")

        es.regclientcmd("_dp_cvar_kills", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_time", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_maxmap", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_lastmaps", "dm_python/cvarValue", "[dm_python] internal command for in-game config")

    def __contains__(self, item):
        return item in map(lambda steamid: steamid.strip(), str(self.steamid).split(","))

    def __getitem__(self, item):
        if item == "admin": return (self.admin, None)
        elif item == "command": return (self.command, None)
        elif item == "timeout": return (self.timeout, int())
        elif item == "method": return (self.method, ("es_tools", "sp_extensions"))
        elif item == "random": return (self.random, ("0", "1"))
        elif item == "respawn": return (self.respawn, int())
        elif item == "dissolver": return (self.dissolver, ("0", "1"))

        elif item == "assaultsuit": return (self.assaultsuit, ("0", "1"))
        elif item == "nightvision": return (self.nightvision, ("0", "1"))
        elif item == "hegrenade": return (self.hegrenade, int())
        elif item == "flashbang": return (self.flashbang, int())
        elif item == "smokegrenade": return (self.smokegrenade, int())

        elif item == "kills": return (self.kills, int())
        elif item == "time": return (self.time, int())
        elif item == "maxmap": return (self.maxmap, int())
        elif item == "lastmaps": return (self.lastmaps, int())

    def saveCfg(self):
        try:
            config = open(self.cfgpath + "config.cfg", "w")
            config.write(
                "// config.cfg for dm_python script\n" +
                "// 2010/06/16 version 2.1p by DoCky\n\n\n" +
                '// X = Administrator steamid\ndp_admin_steamid "%s"\n\n' % self.steamid +
                '// X = Administration menu command\ndp_admin_command "%s"\n\n' % self.admin +
                '// X = deathmatch menu command\ndp_menu_command "%s"\n\n' % self.command +
                '// X = close menu after X second, 0 = do not close automatically\ndp_menu_timeout "%s"\n\n' % self.timeout +
                '// X = plugin used for respawn a player, "es_tools" or "sp_extensions" (SPE)\ndp_respawn_method "%s"\n\n' % self.method +
                '// 1 = respawn player at his team spawn\ndp_respawn_random "%s"\n\n' % self.random +
                '// X = time for respawn a player\ndp_respawn_time "%s"\n\n' % self.respawn +
                '// 1 = dissolve ragdoll\ndp_ragdoll_dissolver "%s"' % self.dissolver)
            config.close()
        except IOError: es.dbgmsg(0, "dm_python: cannot read file cfg/dm_python/config.cfg")

        try:
            items = open(self.cfgpath + "items.cfg", "w")
            items.write(
                "// items.cfg for dm_python script\n" +
                "// 2010/06/16 version 2.1p by DoCky\n\n\n" +
                '// 1 = give kevlar and helmet\ndp_give_assaultsuit "%s"\n\n' % self.assaultsuit +
                '// 1 = give nightvision\ndp_give_nightvision "%s"\n\n' % self.nightvision +
                '// X = give nightvision\ndp_hegrenade_max "%s"\n\n' % self.hegrenade +
                '// X = flashbang max\ndp_flashbang_max "%s"\n\n' % self.flashbang +
                '// X = smokegrenade max\ndp_smokegrenade_max "%s"\n\n' % self.smokegrenade +
                '// X = allowed primary weapons for bots, 0 = all\ndp_bot_primary "%s"\n\n' % self.botPrimary +
                '// X = allowed secondary weapons for bots, 0 = all\ndp_bot_secondary "%s"\n\n' % self.botSecondary)
            items.close()
        except IOError: es.dbgmsg(0, "dm_python: cannot read file cfg/dm_python/items.cfg")

        try:
            items = open(self.cfgpath + "votemap.cfg", "w")
            items.write(
                "// votemap.cfg for dm_python script\n" +
                "// 2010/06/16 version 2.1p by DoCky\n\n\n" +
                '// X = submit votemap after X kill, 0 = disable votemap\ndp_vote_kills "%s"\n\n' % self.kills +
                '// X = time for vote (sec)\ndp_vote_time "%s"\n\n' % self.time +
                '// X = number of map added into the vote\ndp_vote_maxmap "%s"\n\n' % self.maxmap +
                '// X = don\'t add the X last maps played into the vote\ndp_vote_lastmaps "%s"\n\n' % self.lastmaps)
            items.close()
        except IOError: es.dbgmsg(0, "dm_python: cannot read file cfg/dm_python/votemap.cfg")

    def execCfg(self):
        es.server.cmd("es_xmexec dm_python/config.cfg")
        es.server.cmd("es_xmexec dm_python/items.cfg")
        es.server.cmd("es_xmexec dm_python/votemap.cfg")

    def createCmd(self):
        self.deleteCmd()
        for word in map(lambda word: word.strip(), str(self.command).split(",")):
            command.add(word)
            es.regsaycmd(word, "dm_python/deathmatchMenu", "[dm_python] deathmatch menu acces")
            es.regclientcmd(word, "dm_python/deathmatchMenu", "[dm_python] deathmatch menu acces")

        for word in map(lambda word: word.strip(), str(self.admin).split(",")):
            command.add(word)
            es.regsaycmd(word, "dm_python/AdministrationMenu", "[dm_python] Administration menu acces")
            es.regclientcmd(word, "dm_python/AdministrationMenu", "[dm_python] Administration menu acces")

    def deleteCmd(self):
        for word in command:
            es.unregsaycmd(word)
            es.unregclientcmd(word)
        for word in admin:
            es.unregsaycmd(word)
            es.unregclientcmd(word)
        command.clear(), admin.clear()

    def unload(self):
        self.saveCfg()
        self.deleteCmd()

        es.unregclientcmd("_dp_cvar_admin")
        es.unregclientcmd("_dp_cvar_command")
        es.unregclientcmd("_dp_cvar_timeout")
        es.unregclientcmd("_dp_cvar_method")
        es.unregclientcmd("_dp_cvar_random")
        es.unregclientcmd("_dp_cvar_respawn")
        es.unregclientcmd("_dp_cvar_dissolver")

        es.unregclientcmd("_dp_cvar_assaultsuit")
        es.unregclientcmd("_dp_cvar_nightvision")
        es.unregclientcmd("_dp_cvar_hegrenade")
        es.unregclientcmd("_dp_cvar_flashbang")
        es.unregclientcmd("_dp_cvar_smokegrenade")

        es.regclientcmd("_dp_cvar_kills")
        es.regclientcmd("_dp_cvar_time")
        es.regclientcmd("_dp_cvar_maxmap")
        es.regclientcmd("_dp_cvar_lastmaps")
