# -*- coding:Utf-8 -*-
import es, psyco, dm_python, gamethread, langlib, playerlib, simplemenulib
psyco.full()


class DmPlayer(object):
    """ Player Management """
    def __init__(self, userid):
        self.primary = None
        self.secondary = "weapon_deagle"
        self.hegrenade = 0
        self.flashbang = 0
        self.smokegrenade = 0

        self.indexspawn = -1
        self.firstspawn = True
        self.userid = int(userid)
        self.isbot = es.isbot(userid)
        lang = es.getclientvar(userid, "cl_language")
        self.lang = langlib.getLangAbbreviation(lang) if lang else "en"

    def i_block(self):
        status = 5
        sx, sy, sz = es.getplayerlocation(self.userid)
        for userid in es.getUseridList():
            if userid <> self.userid:
                ux, uy, uz = es.getplayerlocation(userid)
                if ((sx - ux) ** 2 + (sy - uy) ** 2 + (sz - uz) ** 2) ** 0.5 <= 150:
                    gamethread.delayedname(1, "_dm_python_thread_%s" % self.userid, self.i_block)
                    status = 2
                    break
        es.setplayerprop(self.userid, "CBaseEntity.m_CollisionGroup", status)

    def spawn(self, team):
        team = int(team)
        self.hegrenade = 0
        self.flashbang = 0
        self.smokegrenade = 0

        es.server.queuecmd('es_xfire %s game_weapon_manager addoutput "maxpieces 0"' % self.userid)
        gamethread.cancelDelayed("_dm_python_thread_%s" % self.userid)
        user = playerlib.getPlayer(self.userid)
        self.i_block()

        # give items
        if es.getInt("dp_give_assaultsuit"): es.server.queuecmd("es_xgive %s item_assaultsuit" % self.userid)
        if es.getInt("dp_give_nightvision"): es.server.queuecmd("es_xgive %s item_nvgs" % self.userid)
        if es.getInt("dp_hegrenade_max"): es.server.queuecmd("es_xgive %s weapon_hegrenade" % self.userid)
        if es.getInt("dp_flashbang_max"): es.server.queuecmd("es_xgive %s weapon_flashbang" % self.userid)
        if es.getInt("dp_smokegrenade_max"): es.server.queuecmd("es_xgive %s weapon_smokegrenade" % self.userid)

        # remove primary and secondary weapons if they're not corresponding to player's selection
        primary, secondary = str(user.primary), str(user.secondary)
        if primary <> "0" and primary <> self.primary: es.server.queuecmd("es_xremove %s" % user.getWeaponIndex(primary))
        if secondary <> "0" and secondary <> self.secondary: es.server.queuecmd("es_xremove %s" % user.getWeaponIndex(secondary))

        # give primary and secondary weapons to player
        if self.isbot:
            primary, secondary = dm_python.weapon.botPrimary(), dm_python.weapon.botSecondary()
            if primary is not None: es.server.queuecmd( "es_xgive %s weapon_%s" % (self.userid, primary))
            if secondary is not None: es.server.queuecmd( "es_xgive %s weapon_%s" % (self.userid, secondary))

        else:
            if self.primary is None: self.primary = "weapon_ak47" if team == 2 else "weapon_m4a1"
            es.server.queuecmd("es_xgive %s %s" % (self.userid, self.primary))
            es.server.queuecmd("es_xgive %s %s" % (self.userid, self.secondary))
            es.delayed(.1, "es_xsexec %s use %s" % (self.userid, self.primary))

            # send deathmatch menu at first spawn... or not...
            if simplemenulib.isqueued(self.userid, "_dm_python_Administration_menu", 1): dm_python.AdministrationUpdate(self.userid)
            elif self.firstspawn:
                self.firstspawn = False
                menu = simplemenulib.active(self.userid)["name"]
                if not menu in simplemenulib.getlist("_dm_python_list_menu"): simplemenulib.send(self.userid, "_dm_python_categorie_menu")

    def unload(self):
        gamethread.cancelDelayed("_dm_python_thread_%s" % self.userid)
        menu = simplemenulib.active(self.userid)["name"]
        if menu in simplemenulib.getlist("_dm_python_list_menu"): simplemenulib.close(self.userid, menu)
